; +
; !TF:	!ZF
;  TF:	0, ZF
;
; 86:	11 -> 00(TF)
; CM:	11 -> SL(TF)
;
TrRpl proc uses ebx
	mov ecx,8
	xor ebx,ebx
	mov dx,ss
	.repeat
		mov eax,11B
		mov ss,dx
		mov ds,ax
		mov ss,dx
		mov ax,ds
		mov ds,dx
		add ebx,eax
	.untilcxz
	mov eax,ebx
	.if Eax
		shr eax,3
		sub ax,dx
	.endif
	ret
TrRpl endp

; +-(W10?)
; !TF:	0x23, !ZF
;  TF:	0, ZF

Tr86Gs proc C
	mov ax,ss
	mov ss,ax
	mov gs,ax
	mov ss,ax
	mov ax,gs
	test ax,ax
	ret
Tr86Gs endp

; +
;  TF:	CF, 0x8
; !TF:	!CF
;
TrCMGs proc uses ebx esi
	mov esi,8
	xor eax,eax
	xor ecx,ecx
	xor edx,edx
	xor ebx,ebx
	mov cx,ss
	.repeat
		mov ss,cx
		mov gs,dx
		mov ss,cx
		mov bx,gs
		add eax,ebx
		dec esi
	.until Zero?
	mov gs,cx
	div ecx
	bt eax,3
	ret
TrCMGs endp

; +
; Zero if !TF.
;
Tr86Sexit proc
	%ENVP Eax
	mov eax,[eax].Yield
	Call NtGateSid
	not ecx
	lea eax,[ecx][esp][3]
	ret
Tr86Sexit endp

;
; EFLAGS -> R11 -> SYSRET
;
Tr64GetSexitFlags proc C
	DB 4CH, 89H, 0D8H	; mov rax,r11
	%RETFN
Tr64GetSexitFlags endp

;
; Carry(TRUE) if TF.
;
TrCMSexitFlags proc
	%ENVP Eax
	mov eax,[eax].Yield
	Call NtGateSid
	%CALL64 Tr64GetSexitFlags
	bt eax,8	; TF
	setc al
	movzx eax,al
	ret
TrCMSexitFlags endp
