.data
g_LogU		UNICODE_STRING <>
g_Log		HANDLE ?

.code
FileStandardInformation	equ 5

FILE_STANDARD_INFORMATION struct
AllocationSize		LARGE_INTEGER <>
EndOfFile			LARGE_INTEGER <>
NumberOflinks		ULONG ?
DeletePending		BOOLEAN ?
Directory			BOOLEAN ?
FILE_STANDARD_INFORMATION ends
PFILE_STANDARD_INFORMATION typedef ptr FILE_STANDARD_INFORMATION

; +
;
LgNew proc $Log:PSTR
Local LogU:UNICODE_STRING
Local OA:OBJECT_ATTRIBUTES
Local Io:IO_STATUS_BLOCK
Local Log:HANDLE
	invoke RtlCreateUnicodeStringFromAsciiz, addr LogU, $Log
	invoke RtlDosPathNameToNtPathName_U, LogU.Buffer, addr g_LogU, NULL, NULL
	xor eax,eax
	lea ecx,g_LogU
	mov OA.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov OA.hRootDirectory,eax
	mov OA.uAttributes,eax
	mov OA.pSecurityDescriptor,eax
	mov OA.pSecurityQualityOfService,eax
	mov OA.pObjectName,ecx
	invoke ZwCreateFile, addr Log, FILE_ALL_ACCESS, addr OA, addr Io, NULL, FILE_ATTRIBUTE_NORMAL, 0, FILE_OVERWRITE_IF, FILE_RANDOM_ACCESS, NULL, 0
	push eax
	invoke RtlFreeUnicodeString, addr LogU
	pop eax
	.if !Eax
		invoke ZwClose, Log
	.endif
	ret
LgNew endp

; +
;
LgAdd proc $Msg:PSTR, S1ze:ULONG
Local OA:OBJECT_ATTRIBUTES
Local Log:HANDLE
Local File:FILE_STANDARD_INFORMATION
Local Io:IO_STATUS_BLOCK
	xor eax,eax
	lea ecx,g_LogU
	mov OA.uLength,sizeof(OBJECT_ATTRIBUTES)
	mov OA.hRootDirectory,eax
	mov OA.uAttributes,eax
	mov OA.pSecurityDescriptor,eax
	mov OA.pSecurityQualityOfService,eax
	mov OA.pObjectName,ecx
	invoke ZwOpenFile, addr Log, FILE_ALL_ACCESS, addr OA, addr Io, 0, FILE_RANDOM_ACCESS
	.if !Eax
		invoke ZwQueryInformationFile, Log, addr Io, addr File, sizeof(FILE_STANDARD_INFORMATION), FileStandardInformation
		.if !Eax
			invoke ZwWriteFile, Log, 0, NULL, NULL, addr Io, $Msg, S1ze, addr File.EndOfFile, NULL
		.endif
		push eax
		invoke ZwClose, Log
		pop eax
	.endif
	ret
LgAdd endp

; +
;
PsGetName proc uses esi edi Pid:ULONG, $Name:PSTR
Local Cid:CLIENT_ID
Local Process:HANDLE
Local Reql:ULONG
Local Ps[MAX_PATH*2]:CHAR
	invoke ZwQueryInformationProcess, NtCurrentProcess, ProcessImageFileName, addr Ps, MAX_PATH*2, addr Reql
	.if !Eax
		mov edi,UNICODE_STRING.Buffer[Ps]
		movzx ecx,UNICODE_STRING._Length[Ps]
		add edi,ecx
		mov eax,"\"
		std
		repne scasw
		cld
		add edi,4
		not cx
		mov esi,$Name
		add cx,UNICODE_STRING._Length[Ps]
		mov edx,ecx
		xchg esi,edi
		.repeat
			lodsw
			stosb
			dec ecx
		.until Zero?
		lea eax,[edx][-1]
	.else
		xor eax,eax
	.endif
Exit:
	ret
PsGetName endp

$Format	CHAR "0x%X_%s_.log", 0

LgPrint proc
Local Buffer[MAX_PATH]:CHAR
	mov eax,D[ebp][8]
	lea ecx,[ebp][12]
	invoke vsprintf, addr Buffer, Eax, Ecx
	invoke LgAdd, addr Buffer, Eax
	ret
LgPrint endp

; +
; 
	assume fs:nothing
LgInit proc
Local $Ps[MAX_PATH]:CHAR
Local $Log[MAX_PATH]:CHAR
	invoke PsGetName, fs:[TEB.Cid.UniqueProcess], addr $Ps

	lea eax,$Ps
	push eax
	push fs:[TEB.Cid.UniqueProcess]
	invoke vsprintf, addr $Log, addr $Format, Esp
	add esp,8
	invoke LgNew, addr $Log
	ret
LgInit endp
